<?php

    namespace Modules\Lpj\Http\Controllers;

    use App\Http\Controllers\Controller;
    use Exception;
    use Illuminate\Http\Request;
    use Maatwebsite\Excel\Facades\Excel;
    use Modules\Lpj\Exports\JenisFasilitasKreditExport;
    use Modules\Lpj\Http\Requests\JenisFasilitasKreditRequest;
    use Modules\Lpj\Models\JenisFasilitasKredit;
    use Modules\Lpj\Http\Library\LpjHelpers;

    class JenisFasilitasKreditController extends Controller
    {
        public $user;

        public function index()
        {
            return view('lpj::jenis_fasilitas_kredit.index');
        }

        public function store(JenisFasilitasKreditRequest $request)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Save to database

                    JenisFasilitasKredit::create($validate);
                    return redirect()
                        ->route('basicdata.jenis-fasilitas-kredit.index')
                        ->with('success', 'Jenis Fasilitas Kredit created successfully');
                } catch (Exception $e) {dd($e);
                    return redirect()
                        ->route('basicdata.jenis-fasilitas-kredit.create')
                        ->with('error', 'Failed to create jenis fasilitas kredit');
                }
            }
        }

        public function create()
        {
            return view('lpj::jenis_fasilitas_kredit.create');
        }

        public function edit($id)
        {
            $jenisFasilitasKredit = JenisFasilitasKredit::find($id);
            return view('lpj::jenis_fasilitas_kredit.create', compact('jenisFasilitasKredit'));
        }

        public function update(JenisFasilitasKreditRequest $request, $id)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Update in database
                    $jenisFasilitasKredit = JenisFasilitasKredit::find($id);

                    // andy add
                    $validate['name'] =strtoupper($request->name);
                    // andy add

                    $jenisFasilitasKredit->update($validate);
                    return redirect()
                        ->route('basicdata.jenis-fasilitas-kredit.index')
                        ->with('success', 'Jenis Fasilitas Kredit updated successfully');
                } catch (Exception $e) {dd($e);
                    return redirect()
                        ->route('basicdata.jenis-fasilitas-kredit.edit', $id)
                        ->with('error', 'Failed to update jenis fasilitas kredit');
                }
            }
        }

        public function destroy($id)
        {
            try {
                // Delete from database
                $jenisFasilitasKredit = JenisFasilitasKredit::find($id);
                $jenisFasilitasKredit->delete();

                echo json_encode(['success' => true, 'message' => 'Jenis Fasilitas Kredit deleted successfully']);
            } catch (Exception $e) {
                echo json_encode(['success' => false, 'message' => 'Failed to delete jenis fasilitas kredit']);
            }
        }

        public function dataForDatatables(Request $request)
        {
            if (is_null($this->user) || !$this->user->can('jenis_fasilitas_kredit.view')) {
                //abort(403, 'Sorry! You are not allowed to view users.');
            }

            // Retrieve data from the database
            $query = JenisFasilitasKredit::query();

            // Apply search filter if provided
            if ($request->has('search') && !empty($request->get('search'))) {
                $search = $request->get('search');
                $query->where(function ($q) use ($search) {
                    $q->where('code', 'LIKE', "%$search%");
                    $q->orWhere('name', 'LIKE', "%$search%");
                });
            }

            // Apply sorting if provided
            if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
                $order  = $request->get('sortOrder');
                $column = $request->get('sortField');
                $query->orderBy($column, $order);
            }

            // Get the total count of records
            $totalRecords = $query->count();

            // Apply pagination if provided
            if ($request->has('page') && $request->has('size')) {
                $page   = $request->get('page');
                $size   = $request->get('size');
                $offset = ($page - 1) * $size; // Calculate the offset

                $query->skip($offset)->take($size);
            }

            // Get the filtered count of records
            $filteredRecords = $query->count();

            // Get the data for the current page
            $data = $query->get();

            // Calculate the page count
            $pageCount = ceil($totalRecords / $request->get('size'));

            // Calculate the current page number
            $currentPage = 0 + 1;

            // Return the response data as a JSON object
            return response()->json([
                'draw'            => $request->get('draw'),
                'recordsTotal'    => $totalRecords,
                'recordsFiltered' => $filteredRecords,
                'pageCount'       => $pageCount,
                'page'            => $currentPage,
                'totalCount'      => $totalRecords,
                'data'            => $data,
            ]);
        }

        public function export()
        {
            return Excel::download(new JenisFasilitasKreditExport, 'jenis_fasilitas_kredit.xlsx');
        }
    }
